var $ = require('jquery');
var jstree = require('jstree');

module.exports = {
	toggleSidebar: function() {
		$('.toggle-sidebar').click(function() {
			$('.HolyGrail-sidebar').toggle();
		});		
	},

    /* handle sensor tree in sidebar */
	getSensorList: function(uri, db) {
		var self = this;
        uri = uri + db + '.json'
		
		$.getJSON(uri, function(data) {		
			self.createTree(data.modules);
		});

	},
	createTree: function(data) {
		var parse = function(data) {
			var keys = [];
			var res = [];
			for (k in data) {
				keys.push(k);
			}
			for (k in keys.sort()) {
				key = keys[k]
				res.push({
					'text': key,
					'children': data[key] 
				})
			}
			return res;			
		};
		
		// parse data
		data = parse(data);
		
		// render tree
		$('#sidebar-sensor-tree').jstree({
			'core': { 'data': data},
			'plugins': [ 'wholerow', 'checkbox', 'search' ],
			'search': {'show_only_matches': true}
		});

		// search box
		var to = false;
		$('#sidebar-search > input').keyup(function () {
			if(to) { clearTimeout(to); }
    		to = setTimeout(function () {
      			var v = $('#sidebar-search > input').val();
      			$('#sidebar-sensor-tree').jstree(true).search(v);
    		}, 250);
		});
	},

    /* Handle Sensor Set */
    sensorSet: function(sets) {
        var list = $('<div></div>');
        list.addClass('list-group');
        var i = 0;
        for (s in sets) {
            i = i + 1;
            var item = $('<a></a>');
            item.addClass('list-group-item').text(s);
            item.attr('id', 'set-'+i);
            item.data({'sensors': sets[s]});
            item.onClick(function() {
                
                $('#sidebar-sensor-tree').jstree({

                });
            });
            list.append(item);
        }
        $('#sidebar-control').append(list);
    },

	init: function(config) {
        var uri = config.uri;
        var db = config.database;
        
		this.toggleSidebar();
		this.getSensorList(uri, db);
        this.sensorSet(config.sensorSets);
	}
};
